"use strict";
var CompoundIndexMetadata_1 = require("../../metadata/CompoundIndexMetadata");
var typeorm_1 = require("../../typeorm");
/**
 * Compound indexes must be set on entity classes and must specify fields to be indexed.
 */
function CompoundIndex(fields) {
    return function (cls) {
        typeorm_1.defaultMetadataStorage().compoundIndexMetadatas.add(new CompoundIndexMetadata_1.CompoundIndexMetadata(cls, fields));
    };
}
exports.CompoundIndex = CompoundIndex;
//# sourceMappingURL=CompoundIndex.js.map