import { TableMetadata } from "./TableMetadata";
import { ColumnMetadata } from "./ColumnMetadata";
import { RelationMetadata } from "./RelationMetadata";
import { IndexMetadata } from "./IndexMetadata";
import { CompoundIndexMetadata } from "./CompoundIndexMetadata";
import { ForeignKeyMetadata } from "./ForeignKeyMetadata";
/**
 * Contains all entity metadata.
 */
export declare class EntityMetadata {
    readonly table: TableMetadata;
    readonly columns: ColumnMetadata[];
    readonly relations: RelationMetadata[];
    readonly indices: IndexMetadata[];
    readonly compoundIndices: CompoundIndexMetadata[];
    readonly foreignKeys: ForeignKeyMetadata[];
    constructor(table: TableMetadata, columns: ColumnMetadata[], relations: RelationMetadata[], indices: IndexMetadata[], compoundIndices: CompoundIndexMetadata[], foreignKeys: ForeignKeyMetadata[]);
    readonly name: string;
    readonly target: Function;
    readonly oneToOneRelations: RelationMetadata[];
    readonly ownerOneToOneRelations: RelationMetadata[];
    readonly oneToManyRelations: RelationMetadata[];
    readonly manyToOneRelations: RelationMetadata[];
    readonly manyToManyRelations: RelationMetadata[];
    readonly ownerManyToManyRelations: RelationMetadata[];
    readonly primaryColumn: ColumnMetadata;
    readonly createDateColumn: ColumnMetadata;
    readonly updateDateColumn: ColumnMetadata;
    readonly hasPrimaryKey: boolean;
    /**
     * Creates a new entity.
     */
    create(): any;
    createPropertiesMap(): any;
    getEntityId(entity: any): any;
    hasColumnWithPropertyName(propertyName: string): boolean;
    hasColumnWithDbName(name: string): boolean;
    findColumnWithPropertyName(propertyName: string): ColumnMetadata;
    findColumnWithDbName(name: string): ColumnMetadata;
    hasRelationWithPropertyName(propertyName: string): boolean;
    hasRelationWithDbName(dbName: string): boolean;
    findRelationWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithDbName(propertyName: string): RelationMetadata;
    findRelationWithOneWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithOneWithDbName(name: string): RelationMetadata;
    findRelationWithManyWithPropertyName(propertyName: string): RelationMetadata;
    findRelationWithManyWithDbName(name: string): RelationMetadata;
    hasRelationWithOneWithPropertyName(propertyName: string): boolean;
    hasRelationWithManyWithPropertyName(propertyName: string): boolean;
    hasRelationWithOneWithName(name: string): boolean;
    hasRelationWithManyWithName(name: string): boolean;
}
