import { NamingStrategyInterface } from "../naming-strategy/NamingStrategy";
import { TargetMetadata } from "./TargetMetadata";
/**
 * This metadata interface contains all information about specific table.
 */
export declare class TableMetadata extends TargetMetadata {
    /**
     * Naming strategy used to generate and normalize table name.
     */
    namingStrategy: NamingStrategyInterface;
    /**
     * Indicates if this table is abstract or not. Regular tables can inherit columns from abstract tables.
     */
    readonly isAbstract: boolean;
    /**
     * Table name in the database.
     */
    private _name;
    constructor(target?: Function, name?: string);
    constructor(target: Function, isAbstract: boolean);
    /**
     * Table name in the database.
     */
    readonly name: any;
    /**
     * Checks if this table is inherited from another table.
     */
    isInherited(anotherTable: TableMetadata): boolean;
}
